#pragma once

#include "CommonCode/Data Storage/DataStorer.h"
#include "CommonCode/Data Storage/EventStorageClient.h"
#include "CommonCode\RTOS abstraction layer\config.h"

#include "SideScanThread.h"
#include "NavThread.h"
#include "ImageProcessor.h"
#include "ReconDriver.h"

class CCableDetector
{
public:
	CCableDetector();
	virtual ~CCableDetector();

	void activate();
	void wait();
	void gpps();
	void readConfig();

	int getSideScanPort() { return m_ssPort; }
	int getNavPort() { return m_navPort; }
	char* getCableTrackerIP() { return m_cableTrackerIP; }
	CSideScanThread * getSideScanThread() { return m_pSideScanThread; }
	CNavThread * getNavThread() { return m_pNavThread; }
	ImageProcessor * getImageProcessorThread() { return m_pImageProcessor; }

	int m_cableTres;
	bool m_useCanny;
	int m_cannyMinTres;
	int m_cannyMaxTres;
	int m_houghTransform;
	int m_houghTreshold;
	int m_houghMinLineLength;
	int m_houghMaxLineGap;
	int m_thetaResolution;
	int m_rhoResolution;
	int m_arraysIncluded;
	int m_pauseMillisec;
	int m_skipArrays;
	double m_accuReduction;
	bool m_bSaveImages;
	double m_TVGMultiplier;
	double m_maxAngRate;
private:
	char m_cableTrackerIP[128];
	int m_navPort;
	int m_ssPort;
	
	CNavThread *m_pNavThread;
	CSideScanThread *m_pSideScanThread;
	ImageProcessor *m_pImageProcessor;
};