
#include "NavThread.h"
#include "CableDetector.h"

#define BUFLEN 100  //Max length of buffer

CNavThread::CNavThread(CCableDetector *pParent) :
	m_pParent(pParent),
	m_bRunning(false)
{
	//std::cout << "NavThread: Size of header: " << sizeof(NavDataHeader) << std::endl;
}

CNavThread::~CNavThread()
{
	CloseHandle(navHandle);
	closesocket(m_socket);
	WSACleanup();
}

static DWORD WINAPI StaticThreadStart(void* Param)
{
	CNavThread* This = (CNavThread*)Param;
	return This->main();
}

unsigned int __stdcall navThreadStart(void* data)
{
	//printf("CNavThread: _beginthreadex thread id: %d \n", GetCurrentThreadId());
	CNavThread* This = (CNavThread*)data;
	return This->main();
}

DWORD CNavThread::main()
{
	int slen = sizeof(si_other);
	char buf[BUFLEN];
	char message[BUFLEN] = "heisann";

	//int test = GetConfigIntFromFile(m_pParent->getConfigFileName(), "CableDetector", "NavPort", m_port);

	std::cout << "CNavThread running." << std::endl;
	while (true)
	{
		//message[0] ++;
		Sleep(50);

		//std::cout << "port: " << m_port << std::endl;

		//printf("Enter message : ");
		//std::cin.getline(message, 20);

		//send the message
		if (sendto(m_socket, message, strlen(message), 0, (struct sockaddr *) &si_other, slen) == SOCKET_ERROR)
		{
			printf("CNavThread: sendto() failed with error code : %d\n", WSAGetLastError());
			//exit(EXIT_FAILURE);
		}

		//std::cout << "sending message: " << message << std::endl;

		//receive a reply and print it
		//clear the buffer by filling null, it might have previously received data
		memset(buf, '\0', BUFLEN);

		//try to receive some data, this is a blocking call
		if (recvfrom(m_socket, buf, BUFLEN, 0, (struct sockaddr *) &si_other, &slen) == SOCKET_ERROR)
		{
			//printf("CNavThread: recvfrom() failed with error code : %d\n", WSAGetLastError());
			//exit(EXIT_FAILURE);
		}
		else {
			memcpy(&posDataStruct, buf, sizeof(NavDataHeader));

			//std::cout << "CNavThread: timestamp: " << posDataStruct.m_nTimeStamp << std::endl;
			//std::cout << "CNavThread: heading: " << posDataStruct.m_dHeading << std::endl;
			//std::cout << "CNavThread: latitude: " << posDataStruct.m_dLatitude << std::endl;
		}
	}
}

bool CNavThread::startThread()
{
	// Check if module has been initialized, if not, initialize module now
	if (!initializeWinsock())
	{
		WSACleanup();
		// Log the event to the event log
		//m_pParent->storeEventString("CNavThread: Failed to initialize module.");
		std::cout << "CableDetector::CNavThread::initializeWinsock() failed. Retrying..." << std::endl;
		Sleep(1000);
		return false;
	}

	//DWORD myThreadID;
	//navHandle = CreateThread(0, 0, StaticThreadStart, (void*) this, 0, &myThreadID);
	navHandle = (HANDLE)_beginthreadex(0, 0, &navThreadStart, (void*) this, 0, 0);

	m_bRunning = true;

	return m_bRunning;
}

bool CNavThread::initializeWinsock()
{
	WSADATA wsa;

	//Initialise winsock
	printf("CNavThread: Initialising Winsock...\n");
	if (WSAStartup(MAKEWORD(2, 2), &wsa) != 0)
	{
		printf("CNavThread: Winsock initialization failed. Error Code : %d\n", WSAGetLastError());
		return false;
	}
	printf("CNavThread: Winsock Initialised.\n");

	//create socket
	if ((m_socket = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) == SOCKET_ERROR)
	{
		printf("CNavThread: socket() failed with error code : %d\n", WSAGetLastError());
		return false;
	}

	//setup address structure
	memset((char *)&si_other, 0, sizeof(si_other));
	si_other.sin_family = AF_INET;
	si_other.sin_port = htons(m_pParent->getNavPort());
	si_other.sin_addr.S_un.S_addr = inet_addr(m_pParent->getCableTrackerIP());

	//For nonblocking udp receive function
	//u_long iMode = 1;
	//ioctlsocket(m_socket, FIONBIO, &iMode);

	return true;
}