#pragma once
#ifndef WIN32_LEAN_AND_MEAN			//prevents windows.h from including winsock.h
#define WIN32_LEAN_AND_MEAN
#endif

#include <windows.h>
#include <process.h>

#define _WINSOCK_DEPRECATED_NO_WARNINGS

#include <winsock2.h>
#include <ws2tcpip.h>
#include <stdio.h>
#include <iostream>

#pragma comment(lib, "Ws2_32.lib")

class CCableDetector;

class CNavThread
{
public:
	CNavThread(CCableDetector *pParent);
	virtual ~CNavThread();

	bool initializeWinsock();
	DWORD main();
	bool startThread();
	HANDLE navHandle;

	struct NavDataHeader
	{
		long long m_nTimeStamp;
		double m_dLatitude;
		double m_dLongitude;
		double m_dDepth;
		double m_dHeading;
		double m_dXVelocityB;
		double m_dZAngRateB;
	} posDataStruct;
private:
	CCableDetector *m_pParent;
	int m_socket;
	struct sockaddr_in si_other;
	bool m_bRunning;
};
