#pragma once

#define _WINSOCK_DEPRECATED_NO_WARNINGS

#include <winsock2.h>
#include <ws2tcpip.h>
#include <stdio.h>
#include <iostream>
#include <vector>

#pragma comment(lib, "Ws2_32.lib")

class CCableDetector;

class CSideScanThread
{
public:
	CSideScanThread(CCableDetector *pParent);
	virtual ~CSideScanThread();

	bool initializeWinsock();
	DWORD main();
	bool startThread();
	bool saveBuf(char* buf);
	int getLinesWritten() { return m_linesWritten; }
	int getSidscanArrayLength() { return m_ssArrayLength; }
	HANDLE ssHandle;
	std::string getOutputFile() { return m_outputFolder + m_outputFile; }
	void sendMessage(char* buf, int bufSize);
	std::string getTimeStart() { return m_timeStart; }
	std::string getOutputFolder() { return m_outputFolder; }

	struct SideScanDataHeader
	{
		float speed;
		float altitude;
		float soundSpeed;
		float secPerLine1;
		float secPerLine2;
	} ssData;
private:
	CCableDetector *m_pParent;
	int m_socket;
	struct sockaddr_in si_other;
	bool m_bRunning;
	int m_linesWritten;
	std::string m_outputFolder;
	std::string m_outputFile;
	int m_ssArrayLength;
	std::string m_timeStart;

	struct NavDataHeader
	{
		long long m_nTimeStamp;
		double m_dLatitude;
		double m_dLongitude;
		double m_dDepth;
		double m_dHeading;
		double m_dXVelocityB;
		double m_dZAngRateB;
	} posDataStruct;
};
