/*
	CtdThread.h

	Copyright: 		Department of Marine Technology, NTNU
	Author: 		Petter Norgren
	Date created: 	2016.09.09
*/

#pragma once

#include "CommonCode/RTOS abstraction layer/Thread.h"
#include "CommonCode/Storable Sensor Data/CTDData.h"
#include "CommonCode/RTOS abstraction layer/CriticalSection.h"

class CRemusReconImpl;

class CtdThread : public OAL::CThread
{
public:
	CtdThread(CRemusReconImpl *pParent);
	virtual ~CtdThread();

	bool initialize();
	bool startThread();
	void stopThread();
	void main();
	bool isRunning() { return m_bRunning; }
	
	void getData(CCTDData &data);

private:
	CRemusReconImpl *m_pParent;
	bool m_bInitialized;
	bool m_bRunning;

	OAL::CCriticalSection m_mutex;
	CCTDData m_data;

	void setData(const CCTDData &data);
};
