/*
	DebugThread.h

	Copyright: 		Department of Marine Technology, NTNU
	Author: 		Petter Norgren
					Date created: 	2016.01.04  PN Created function.
	Revised:
*/
#include <iostream>
#include <vector>

#pragma once

#ifndef PI
#define PI 3.14159265
#endif

#include "CommonCode/RTOS abstraction layer/Thread.h"
#include "CommonCode/RTOS abstraction layer/Timer.h"
#include "CommonCode/RTOS abstraction layer/Event.h"

//class CPluginImpl;
class CRemusReconImpl;
class CSerial;

class CDebugThread : public OAL::CThread
{
public:
	CDebugThread(CRemusReconImpl *pParent);
	virtual ~CDebugThread();

	bool initialize();
	bool startThread();
	void stopThread();
	void main();

private:
	CRemusReconImpl *m_pParent;

	bool m_bInitialized;
	bool m_bRunning;

	int m_navNumber;
	int m_pingNumber;
	int m_ctdNumber;
	double m_startTime;

	std::vector<std::vector<double> > sidescanData;
	std::vector<std::vector<double> > navData;
	std::vector<std::vector<double> > ctdDataMatrix;

	std::vector<std::vector<double> > ReadMatrix(const char *filename, int columns);
	unsigned char* readBMP(char* filename);
	int bmpWidth;
	int bmpHeight;
};