
#pragma once

#include "GuidanceInterface.h"
#include "CommonCode/RTOS abstraction layer/Thread.h"
#include "CommonCode/Socket/CBerkeleySocket.h"

#include <stdio.h>
#include <sstream>
#include <string.h>

#if !defined(PI)
	#define PI 3.14159265359
#endif

class CRemusReconImpl;

class CMagnetometerThread : public OAL::CThread
{
public:
	CMagnetometerThread(CRemusReconImpl *pParent);
	virtual ~CMagnetometerThread();

	//OAL::CCriticalSection m_mutex;

	bool initialize();
	bool startThread();
	void stopThread();
	void main();
	bool initializeWinsock();

	bool isInitalized(){ return m_bInitialized; }
	bool isRunning(){ return m_bRunning; }

	double getCableCrossTrack(){ return m_crossTrackError; }
	double getCableHeadingRad(){ return m_headingCable; }
	unsigned int getMessageNumber() { return m_messageNumber; }
	bool isMeasurementPrecise() {return m_preciseMeasurements; }
private:
	CRemusReconImpl *m_pParent;

	bool m_bInitialized;
	bool m_bRunning;

	bool m_bWinsockEnable;
	char m_IP[128];
	int m_port;

	double m_crossTrackError;
	double m_headingCable;
	unsigned int m_messageNumber;
	bool m_preciseMeasurements;
	CAbsTime m_prevSampleTime;
	bool storeMagnetometerData(unsigned char *pData, size_t nDataLen);

	//winsock
	SOCKET m_socket;
	struct sockaddr_in server, si_other;
};