
#pragma once

#include "CommonCode/RTOS abstraction layer/Thread.h"
#include "CommonCode/Socket/CBerkeleySocket.h"

class CRemusReconImpl;

class CNavThread : public OAL::CThread
{
public:
	CNavThread(CRemusReconImpl *pParent);
	virtual ~CNavThread();

	bool initialize();
	bool startThread();
	void stopThread();
	void main();
	bool initializeWinsock();

	bool isInitalized(){ return m_bInitialized; }
	bool isRunning(){ return m_bRunning; }
private:
	CRemusReconImpl *m_pParent;

	bool m_bInitialized;
	bool m_bRunning;

	//char m_IP[128];
	int m_port;

	//winsock
	SOCKET m_socket;
	struct sockaddr_in server, si_other;

	struct NavDataHeader
	{
		long long m_nTimeStamp;
		double m_dLatitude;
		double m_dLongitude;
		double m_dDepth;
		double m_dHeading;
		double m_dXVelocityB;
		double m_dZAngRateB;
	} posDataStruct;
};