/*******************************
*
* RCMsgDefs.h: Remote Control Test plugin <-> POS protocol definitions
*
* Copyright 2012 KM
*
*******************************/

#ifndef RCMsgDefs_h
#define RCMsgDefs_h


/*--------------------------------------------------------------------------*/
/* Offset to ensure that the error and event sent to OS don't have the		*/
/* same enums																*/
/*--------------------------------------------------------------------------*/
#define RC_OFFSET_ERROR	1
#define RC_OFFSET_EVENT	128


/*--------------------------------------------------------------------------*/
/* Commands sent from OS to plugin											*/
/*--------------------------------------------------------------------------*/
enum RCCmdId
{
    eRCGetRemoteControlStatus,

	eRCEnable,
    eRCDisable,
    eRCEnableDepthOnly,
    eRCDisableDepthOnly,
    eRCEnableDirect,
    eRCDisableDirect,

    eRCSetHeading,
    eRCSetAltitude,
    eRCSetDepth,
    eRCSetSpeed,
    eRCSetRpm,
    eRCSetDirect2,
    eRCSetDirect3,
    eRCSetWaypoint,

	eRCCmdLastCmd,

};

/* Id's for Errors sent from plugin to POS */

enum RCErrorId
{
};


/* Id's for Events reported from plugin to POS */

enum RCEventId
{
	/* Startup seqence complete												*/
	eRCEventPowerOn   =	RC_OFFSET_EVENT, 
	eRCEventPowerOff,	
	eRCEventLoggingOn,
	eRCEventLoggingOff,
	eRCEventOperationOn,
	eRCEventOperationOff,
	eRCEventConnectionFailed,
    eRCEventEnableFailed,
    eRCEventNetworkError,
};

enum RCCmdResponseId {
	eRCCRCmdExecuted,			// Command was executed ok
	eRCCRCmdFailed,				// Tried to execute, but didn't succeed
	eRCCRBadState,				// Command rejected due to systRC state
	eRCCRCmdError,				// Error in command (illegal length or param value)
	eRCCRCmdUnknown,			// Unknown command id
};

#endif //RCMsgDefs_h
