
#pragma once

#include "CommonCode/RTOS abstraction layer/Thread.h"
#include "CommonCode/Socket/CBerkeleySocket.h"

#include <stdio.h>
#include <sstream>
#include <string.h>

class CRemusReconImpl;

class CSideScanThread : public OAL::CThread
{
public:
	CSideScanThread(CRemusReconImpl *pParent);
	virtual ~CSideScanThread();

	bool initialize();
	bool startThread();
	void stopThread();
	void main();
	bool initializeWinsock();
	

	bool isInitalized(){ return m_bInitialized; }
	bool isRunning(){ return m_bRunning; }

	double getCableCrossTrack(){ return m_crossTrack; }
	double getCableHeadingRad(){ return m_headingCable; }
	unsigned int getMessageNumber() { return m_messageNumber; }
private:
	CRemusReconImpl *m_pParent;
	bool storeSideScanData(unsigned char *pData, size_t nDataLen);

	bool m_bInitialized;
	bool m_bRunning;

	bool m_bWinsockEnable;
	char m_IP[128];
	int m_port;

	double m_crossTrack;
	double m_headingCable;
	int m_messageNumber;

	//winsock
	SOCKET m_socket;
	struct sockaddr_in server, si_other;
};